#!/usr/local/bin/perl
use strict;
no strict 'refs';
#-------------------------------------------------------------------------------
# ǡ١ select åץ饰
#					(C)2006-05 nabe / ABK project
#-------------------------------------------------------------------------------
package Satsuki::DB_cache;
our $VERSION = '1.00';
#-------------------------------------------------------------------------------
our $AUTOLOAD;
our $DEBUG;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class       = shift;
	my $ROBJ        = shift;
	my $super_class = $_[0];

	# ƥ饹θƤӽФ
	my $self = $ROBJ->loadpm(@_);
	if (!ref $self) { return $self; }

	# ɸư
	$DEBUG = 0;
	$self->{cache_check}   = 120;	# 120äȤΥå
	$self->{cache_timeout} = 600;	# 600åΤʤå
	$self->{data_copy}     =   1;	# åΥԡ֤

	$self->{_super_class} = 'Satsuki::' . $super_class;
	bless($self, $class);	# Υ饹˴Ϣդ
	return $self;
}

###############################################################################
# ƥ᥽åɤθƤӽФ
###############################################################################
sub AUTOLOAD {
	my $super_class = $_[0]->{_super_class};
	if ($AUTOLOAD eq '') { return; }
	my $x          = rindex($AUTOLOAD, '::');
	my $func       = substr($AUTOLOAD, $x+2);
	my $super_func = $super_class . '::' . $func;
	# ƤӽФ
	return &$super_func(@_);
}
#------------------------------------------------------------------------------
# can ΥС饤
#------------------------------------------------------------------------------
sub can {
	my ($self, $func) = @_;
	my $func = $self->{_super_class} . '::' . $func;
	return (defined &$func);
}

###############################################################################
# С饤ɥ᥽å
###############################################################################
my %select_cache;
my %select_cache_hits;
my %select_cache_tm;
my %select_cache_atime;
my $check_time = 0;
#------------------------------------------------------------------------------
# ǡθ
#------------------------------------------------------------------------------
sub select {
	my ($self, $table, $h) = @_;
	my $select_func = $self->{_super_class} . '::select';
	if ($h->{cache_id} eq '') { return &$select_func(@_); }

	my $ROBJ      = $self->{ROBJ};
	my $cache_id  = $self->{db_id} . $table . ':' . $h->{cache_id};

	# åμưॢȽ
	my $now_tm = $ROBJ->{TM};
	$select_cache_atime{ $cache_id } = $now_tm;
	if ($now_tm > $check_time + $self->{cache_check}) { $self->cache_timeout_check(); }

	# å˥ǡ뤫ǧ
	my $cache;
	my $modified = $self->get_table_lastmodifed( $table );
	if ($modified && $select_cache_tm{ $cache_id } == $modified) {
		$DEBUG && $self->{ROBJ}->debug("[DB_cache] load cache '$cache_id'");
		$ROBJ->update_modtime( $modified );
		if ($h->{require_hits}) { $h->{hits} = $select_cache_hits{ $cache_id }; }
		# å夫ǡԡ
		$cache = $select_cache{ $cache_id };
	} else {
		# ǡɤ߽Фå夹
		$cache = &$select_func(@_);
		$select_cache     { $cache_id } = $cache;
		$select_cache_hits{ $cache_id } = $h->{hits};
		$select_cache_tm  { $cache_id } = $modified;
	}

	# ǡΥԡ
	if (!$self->{data_copy} && !$h->{data_copy}) { return $cache; }	# å夽Τ
	my @ary = @$cache;
	foreach( @ary ) { my %h=%$_; $_=\%h; }
	return \@ary;
}

###############################################################################
# åư
###############################################################################
#------------------------------------------------------------------------------
# åΥꥢ
#------------------------------------------------------------------------------
sub cache_clear {
	undef %select_cache_tm;
	undef %select_cache;
	undef %select_cache_hits;
	undef %select_cache_atime;
	$check_time = 0;
}
#------------------------------------------------------------------------------
# åΥॢȥå
#------------------------------------------------------------------------------
sub cache_timeout_check {
	my ($self) = @_;
	my $now_tm = $self->{ROBJ}->{TM};
	if (! $check_time) { $check_time = $now_tm; return; }
	$check_time = $now_tm;

	$DEBUG && $self->{ROBJ}->debug('[DB_cache] cache timeout check');
	my @delete_keys;
	my $check_tm = $now_tm - $self->{cache_timeout};
	while (my($k,$v) = each(%select_cache_atime)) {
		if ($v < $check_tm) { push(@delete_keys, $k); }
	}
	# å
	foreach(@delete_keys) {
		$DEBUG && $self->{ROBJ}->debug("[DB_cache] delete cache $_");
		delete $select_cache_tm{$_};
		delete $select_cache{$_};
		delete $select_cache_hits{$_};
		delete $select_cache_atime{$_};
	}
}


###############################################################################
# ǥХåϢ
###############################################################################
sub set_debug {
	my ($self, $flag) = @_;
	$DEBUG = $flag;

	my $debug_func = $self->{_super_class} . '::set_debug';
	goto &$debug_func;
}

1;	# ޤʤ
